<template>
    <base-page-vuetify>

        <v-flex slot='main' xs12>
            <v-flex xs4>
                <h2>Profile</h2>

                <error-boundary>
                    <Card :title=this.$store.state.user.email>
                        <div slot="descr">
                            <h6>roles : {{this.$store.state.user.roles}}</h6>
                            <h6>username : {{this.$store.state.user.email}}</h6>
                            <p v-if="this.$store.state.loggedIn" class="card-description">
                                Your token expires in <Timer :date=this.$store.state.decoded.exp_date></Timer> ({{this.$store.state.decoded.exp_date}})
                            </p>

                        </div>
                        <div slot="actions">
                            <v-btn color="primary">Refresh token</v-btn>
                            <v-btn color="primary" @click="trigger">Call API</v-btn>

                        </div>
                    </Card>
                </error-boundary>
            </v-flex>


            <v-flex xs12>
                <h2>Datatable</h2>
                <v-card>
                    <v-card-title>
                        Nutrition
                        <v-spacer></v-spacer>
                        <v-text-field
                                v-model="search"
                                append-icon="search"
                                label="Search"
                                single-line
                                hide-details
                        ></v-text-field>
                    </v-card-title>
                    <v-data-table
                            :headers="headers"
                            :items="users"
                            :search="search"
                    >
                        <template slot="items" slot-scope="props">
                            <td>{{ props.item.username }}</td>
                            <td>{{ props.item.isActive }}</td>
                            <td>{{ props.item.id }}</td>
                        </template>
                        <v-alert slot="no-results" :value="true" color="error" icon="warning">
                            Your search for "{{ search }}" found no results.
                        </v-alert>
                    </v-data-table>
                </v-card>
            </v-flex>
        </v-flex>
        <div slot="foot"></div>

    </base-page-vuetify>
</template>

<script>
    import ErrorBoundary from "../components/ErrorBoundary";
    import VueBootstrap4Table from 'vue-bootstrap4-table';
    import {mapActions} from 'vuex';
    import BasePageVuetify from "./BasePageVuetify";
    import Card from "../components/Card"
    import Timer from "../components/Timer";

    export default {
        name: "Dashboard",
        extends: BasePageVuetify,
        components: {
            Timer,
            Card,
            'vue-bs-datatable': VueBootstrap4Table,
            'error-boundary': ErrorBoundary,
            'base-page-vuetify': BasePageVuetify,
        },
        data: function () {
            return {
                tokenTtl: 0,
                search: '',
                headers: [
                    {
                        text: 'Username',
                        align: 'left',
                        value: 'username'
                    },
                    {text: 'is active', value: 'isActive', align:'left'},
                    {text: 'id', value: 'id', align:'left'},
                ],
                users: [
                ],
                config: {
                    checkbox_rows: true,
                    rows_selectable: true,
                    card_title: "User list",
                    card_icon: 'fa-user',
                }
            }
        },
        methods:{
            ...mapActions(["fetchUsers", "callApi"]),
            trigger() {
                this.callApi().then().catch()
            }
        },
        mounted() {
            this.fetchUsers().then((data) => {
                console.log('users : ', data)
                this.users = data['hydra:member']
            })
        }
    }
</script>

<style scoped>

</style>